package prefuse.controls;

import java.awt.event.MouseEvent;
import java.util.Iterator;

import prefuse.Visualization;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ui.UILib;
import prefuse.visual.AggregateItem;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;
import cytoPrefuse.CytoPrefuse;

public class ClickToSelect extends ControlAdapter {
	private CytoPrefuse cytoPrefuse;
	public ClickToSelect(CytoPrefuse cytoPrefuse) {
		this.cytoPrefuse = cytoPrefuse;
	}
	public void mouseClicked (MouseEvent e){
		if ( UILib.isButtonPressed(e, LEFT_MOUSE_BUTTON) &&
	             e.getClickCount() == 1 )
       {
			//Clicked the background.  Deselect all.
			if (!e.isShiftDown()){
				cytoPrefuse.deselectAll();
			}
       }
	}
	 public void itemClicked(VisualItem item, MouseEvent e) {
		if ( UILib.isButtonPressed(e, LEFT_MOUSE_BUTTON) &&
	             e.getClickCount() == 1 )
        {
			if (item instanceof NodeItem) {
	            Visualization vis = item.getVisualization();
	            TupleSet ts = vis.getFocusGroup(CytoPrefuse.SELECTED);
	            boolean shift = e.isShiftDown();
	            CytoPrefuse cytoPrefuse = (CytoPrefuse) vis.getDisplay(0);
	            if ( !shift ) {
	            	cytoPrefuse.deselectAll();
                    cytoPrefuse.selectSingle(item, true);
	            } else if ( ts.containsTuple(item)) {
	                cytoPrefuse.selectSingle(item,false);
	            } else {
                    cytoPrefuse.selectSingle(item, true);
	            }
			}
        }
		else if (UILib.isButtonPressed(e, LEFT_MOUSE_BUTTON) &&
	            e.getClickCount() == 2){
			if (item instanceof AggregateItem) {
				 Visualization vis = item.getVisualization();
				 TupleSet ts = vis.getFocusGroup(CytoPrefuse.SELECTED);
				 boolean shift = e.isShiftDown();
		      
				 AggregateItem aggItem = (AggregateItem) item;
			    	 
				 Iterator itemsIt = aggItem.items();
				 boolean allSelected = true;
				 while (itemsIt.hasNext()){
					VisualItem groupMember =(VisualItem)itemsIt.next();
					if (groupMember instanceof NodeItem){
						if (!ts.containsTuple(groupMember)){
							allSelected = false;
							break;
						}
					}
				 }
				 if ( !shift ) {
                     cytoPrefuse.deselectAll();
		         }
				 itemsIt = aggItem.items();
				 while (itemsIt.hasNext()){
					VisualItem groupMember =(VisualItem)itemsIt.next();
					if (groupMember instanceof NodeItem) {
						if (allSelected) {
                            cytoPrefuse.selectSingle(groupMember, false);
						}else{
                            cytoPrefuse.selectSingle(groupMember, true);                            
						}
					}
				 }
			}
		}
	 }
}
